---
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.19.0
  name: hostnamegenerators.kuma.io
spec:
  group: kuma.io
  names:
    categories:
    - kuma
    kind: HostnameGenerator
    listKind: HostnameGeneratorList
    plural: hostnamegenerators
    shortNames:
    - hg
    singular: hostnamegenerator
  scope: Namespaced
  versions:
  - name: v1alpha1
    schema:
      openAPIV3Schema:
        description: HostnameGenerator automatically generates DNS hostnames for services
          in the mesh based on customizable templates. It provides a consistent naming
          scheme for service discovery by creating predictable hostnames from service
          labels and metadata, supporting both MeshService, MeshExternalService, and
          MeshMultiZoneService resources.
        properties:
          apiVersion:
            description: |-
              APIVersion defines the versioned schema of this representation of an object.
              Servers should convert recognized schemas to the latest internal value, and
              may reject unrecognized values.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
            type: string
          kind:
            description: |-
              Kind is a string value representing the REST resource this object represents.
              Servers may infer this from the endpoint the client submits requests to.
              Cannot be updated.
              In CamelCase.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
            type: string
          metadata:
            type: object
          spec:
            description: Spec is the specification of the Kuma HostnameGenerator resource.
            properties:
              extension:
                description: Extension struct for a plugin configuration
                properties:
                  config:
                    description: Config freeform configuration for the extension.
                    x-kubernetes-preserve-unknown-fields: true
                  type:
                    description: Type of the extension.
                    type: string
                required:
                - type
                type: object
              selector:
                properties:
                  meshExternalService:
                    properties:
                      matchLabels:
                        additionalProperties:
                          type: string
                        type: object
                    type: object
                  meshMultiZoneService:
                    properties:
                      matchLabels:
                        additionalProperties:
                          type: string
                        type: object
                    type: object
                  meshService:
                    properties:
                      matchLabels:
                        additionalProperties:
                          type: string
                        type: object
                    type: object
                type: object
              template:
                type: string
            required:
            - template
            type: object
        type: object
    served: true
    storage: true
